' *****************************************************************
' *                                                               *
' *       Copyright (c) Fast Corporation, 2007                    *
' *                                                               *
' *   All Rights Reserved.  Unpublished rights  reserved  under   *
' *   the copyright laws of the Japan.                            *
' *                                                               *
' *   The software contained on this media  is  proprietary  to   *
' *   and  embodies  the  confidential  technology  of  Fast      *
' *   Corporation.  Possession, use,  duplication  or             *
' *   dissemination of the software and media is authorized only  *
' *   pursuant to a valid written license from Fast Corporation.  *
' *                                                               *
' *****************************************************************

' -----------------------------------------------------------------
' FVX Sample Program
' C_CAO
'
' 쐬 : K.Yakushinji
'
'  : 2007/02/01 
' -----------------------------------------------------------------
Public Class frmMain

    Private m_blnVideoOpened As Boolean         'rfIfoCXI[vĂ邩
    Private m_strVideoConfFilePath As String    'rfIݒt@CitpXj    
    Private m_blnCanHWBinarize As Boolean       'HWQl\ǂ
    Private m_bCanOffSet As Boolean             'ItZbg\ǂ
    Private m_bCanExposure As Boolean           'IԂ\ǂ
    Private m_bInsFreerun As Boolean            't[ǂ
    Private m_intCaptureType As Integer         'Lv`[^Cv

    Private Sub frmMain_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing

        Timer1.Stop()

        If m_blnVideoOpened Then
            'rfIfoCXI[vĂꍇ̓N[Y܂
            AxFvxVideo1.CloseDevice()
            AxFvxVideo2.CloseDevice()
        End If

    End Sub

    Private Sub frmMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        'rfIfoCX̃I[vԕێϐ̏
        m_blnVideoOpened = False
        btnGrab.Enabled = False
        btnFreerun.Enabled = False

        'gp̊mF
        If My.Forms.frmLicence.ShowDialog() <> Windows.Forms.DialogResult.Yes Then
            End
        End If

        'rfIfoCXI
        setVideoConfFile()

    End Sub

    'rfIݒt@CI
    Private Sub setVideoConfFile()

        Dim intCaptureType As Integer  'Lv`{[h̃^Cv
        Dim intCaptureNum As Integer   'Lv`{[h̖
        Dim intCaptureConnectorNum As Integer 'P{[h̃RlN^
        Dim rtn As Integer
        Dim frmVideoConf As New frmSelectVideoConfFile  'rfIݒt@C
        Dim intErr As Integer
        Dim intErr1 As Integer
        Dim i As Integer

        '2̃{[h2chX2s
        AxFvxImage1.ImageNum = 2
        AxFvxImage2.ImageNum = 2

        'rfIݒt@C̑I
        m_strVideoConfFilePath = ""
        If frmVideoConf.ShowDialog() = Windows.Forms.DialogResult.OK Then
            m_strVideoConfFilePath = frmVideoConf.strVideoConfFilePath
        End If

        If m_strVideoConfFilePath.Length <> 0 Then

            'rfIݒt@CR|[lgɐݒ
            AxFvxVideo1.VideoConfFile = m_strVideoConfFilePath
            AxFvxVideo2.VideoConfFile = m_strVideoConfFilePath

            If m_blnVideoOpened = True Then
                'rfIfoCXI[vĂꍇ͈UN[Y܂
                AxFvxVideo1.CloseDevice()
                AxFvxVideo2.CloseDevice()
            End If

            'rfIfoCX̃I[vԕێϐ̏
            m_blnVideoOpened = False
            btnGrab.Enabled = False
            btnFreerun.Enabled = False

            'ItZbg
            m_bCanOffSet = False
            txtOffset.Enabled = False
            trcOffSet.Enabled = False
            'I
            m_bCanExposure = False
            txtExposure.Enabled = False
            trcExposure.Enabled = False
            'HWQl
            m_blnCanHWBinarize = False
            txtBinLevel.Enabled = False
            trcBinLevel.Enabled = False

            'foCXI[v({[h0)
            Try
                AxFvxVideo1.OpenDevice()
            Catch
                AxFvxVideo1.GetErrReport(intErr)
                MsgBox("rfIfoCX̃I[vɎs܂({[h0) (" + intErr.ToString + ")", vbExclamation, "G[")
            End Try

            If intErr = 0 Then
                Try
                    AxFvxVideo2.OpenDevice()
                Catch
                    AxFvxVideo2.GetErrReport(intErr)
                    MsgBox("rfIfoCX̃I[vɎs܂({[h1) (" + intErr.ToString + ")", vbExclamation, "G[")
                End Try

                If intErr = 0 Then

                    'Lv`{[h^Cv擾
                    AxFvxVideo1.GetCaptureType(intCaptureType)
                    'FVX05ȊO͓s\Ƃ
                    If 7 <> intCaptureType Then
                        MsgBox("FVC05ȊOł͖{@\͎gpł܂", MsgBoxStyle.OkOnly Or MsgBoxStyle.Information, "G[")
                        AxFvxVideo1.CloseDevice()
                        AxFvxVideo2.CloseDevice()
                        m_blnVideoOpened = False
                        Exit Sub
                    End If

                    Threading.Thread.Sleep(200)

                    Try
                        '4ch荞݃p[^ݒ
                        AxFvxVideo1.SetSimGrab(2)          '荞
                        AxFvxVideo1.SetSynchronousMode(2)  '}X^[
                        AxFvxVideo1.SetTrigger(1)          'gK

                        AxFvxVideo2.SetSimGrab(2)          '荞
                        AxFvxVideo2.SetSynchronousMode(1)  'X[u
                        AxFvxVideo2.SetTrigger(2)          'OgK

                    Catch
                        AxFvxVideo1.GetErrReport(intErr)
                        AxFvxVideo2.GetErrReport(intErr1)
                        MsgBox("4ch荞ݐݒɎs܂B")
                    End Try

                    If (intErr = 0) And (intErr1 = 0) Then


                        Try
                            'GrabSync/GrabASync\bhłImegeTCY̕ύXs܂̂ŁA
                            '炩ChangeImageSize\bhɂImagẽTCYύXĂ
                            'i荞݃TCYImagẽTCYႤꍇG[ɂȂ܂j
                            AxFvxVideo1.ChangeImageSize(AxFvxImage1.GetOcx())
                            AxFvxVideo2.ChangeImageSize(AxFvxImage2.GetOcx())

                            Threading.Thread.Sleep(500)

                            '捞
                            rtn = fnGrabSync(5000)

                            If rtn = 0 Then

                                'rfIfoCX̏ԂL
                                m_blnVideoOpened = True
                                btnGrab.Enabled = True
                                btnFreerun.Enabled = True

                                'gK[h
                                cmbTrigger.Items.Clear()
                                cmbTrigger.Items.Add("gK(SW)")
                                cmbTrigger.Items.Add("OgK(Ext)")
                                cmbTrigger.SelectedIndex = 0

                                'rfIItZbg-512`511
                                trcOffSet.Minimum = -512
                                trcOffSet.Maximum = 511
                                lbVideoOffsetMin.Text = -512
                                lbVideoOffsetMax.Text = 511

                                '捞摜
                                cmbImageType.Items.Clear()
                                cmbImageType.Items.Add("")
                                cmbImageType.Items.Add("1f1bit2l")
                                cmbImageType.SelectedIndex = 0

                                m_bCanOffSet = True
                                m_bCanExposure = True
                                m_blnCanHWBinarize = True

                                ' rfIItZbg
                                If (m_bCanOffSet) Then
                                    AxFvxVideo1.GetVideoOffset(i)
                                    trcOffSet.Value = i
                                    txtOffset.Text = i
                                    txtOffset.Enabled = True
                                    trcOffSet.Enabled = True
                                End If

                                ' I
                                If (m_bCanExposure) Then
                                    AxFvxVideo1.GetExposureTime(i)
                                    trcExposure.Value = i / 1000
                                    txtExposure.Text = i / 1000
                                    txtExposure.Enabled = True
                                    trcExposure.Enabled = True
                                End If

                                ' HWQl
                                If (m_blnCanHWBinarize) Then
                                    AxFvxVideo1.GetBinarizeThreshold(i)
                                    trcBinLevel.Value = i
                                    txtBinLevel.Text = i
                                    txtBinLevel.Enabled = True
                                    trcBinLevel.Enabled = True
                                End If
                            Else
                                MsgBox("rfI̎捞Ɏs܂(" + rtn.ToString + ")", MsgBoxStyle.OkOnly Or MsgBoxStyle.Information, "G[")
                            End If

                        Catch

                            'G[
                            AxFvxVideo1.GetErrReport(intErr)
                            If intErr <> 0 Then MsgBox(GetFvxVideoErrMsg(intErr), vbExclamation, "G[")
                            AxFvxVideo2.GetErrReport(intErr1)
                            If intErr1 <> 0 Then MsgBox(GetFvxVideoErrMsg(intErr1), vbExclamation, "G[")

                        End Try
                    End If
                End If
            End If
        End If

        'ʂ̐
        AxFvxDisplayEx1.CreateDisplay()
        AxFvxDisplayEx2.CreateDisplay()
        AxFvxDisplayEx3.CreateDisplay()
        AxFvxDisplayEx4.CreateDisplay()

        'ʂ̕\
        fnDrawImage()

    End Sub

    '荞
    ' nTimeout : msP 0wŃ^CAEgiFVX Ver2.50̂)
    Private Function fnGrabSync(Optional ByVal nTimeout As Long = 0) As Long

        Dim dTime As Double

        Try

            If 0 >= nTimeout Then
                '^CAEg
                AxFvxVideo2.GrabASync(AxFvxImage2.GetOcx())   'X[u
                AxFvxVideo1.GrabSync(AxFvxImage1.GetOcx())    '}X^[
                AxFvxVideo2.GrabASyncStatus()
                fnGrabSync = 0
                Exit Function
            Else
                '^CAEgL
                AxFvxPerformanceCounter2.StartCount()
                AxFvxVideo2.GrabASync(AxFvxImage2.GetOcx())   'X[u
                AxFvxVideo1.GrabASync(AxFvxImage1.GetOcx())   '}X^[
                Do While True
                    If AxFvxVideo2.GrabASyncStatus2() = FVXCOMVIDEOLib.FVX_VIDEO_GRAB_STATUS.videoGrabCompleted Then
                        Exit Do
                    Else
                        AxFvxPerformanceCounter2.StopCount(dTime)
                        If dTime > nTimeout Then
                            AxFvxVideo1.GrabCancel()
                            AxFvxVideo2.GrabCancel()
                            MsgBox("Timeout", vbExclamation, "荞݃G[")
                            Exit Do
                        End If
                        Threading.Thread.Sleep(10)
                    End If
                Loop
                AxFvxVideo1.GrabASyncStatus()
                fnGrabSync = 0
                Exit Function
            End If
        Catch

            Dim intErr As Integer
            AxFvxVideo1.GetErrReport(intErr)
            If 0 = intErr Then
                AxFvxVideo2.GetErrReport(intErr)
            End If

            AxFvxVideo1.GrabCancel()
            AxFvxVideo2.GrabCancel()

            fnGrabSync = intErr

        End Try

    End Function

    '摜\
    Private Sub fnDrawImage()

        AxFvxImage1.CurrentNo = 0
        AxFvxDisplayEx1.DrawImage(AxFvxImage1.GetOcx())
        AxFvxImage1.CurrentNo = 1
        AxFvxDisplayEx2.DrawImage(AxFvxImage1.GetOcx())
        AxFvxImage1.CurrentNo = 0

        AxFvxImage2.CurrentNo = 0
        AxFvxDisplayEx3.DrawImage(AxFvxImage2.GetOcx())
        AxFvxImage2.CurrentNo = 1
        AxFvxDisplayEx4.DrawImage(AxFvxImage2.GetOcx())
        AxFvxImage2.CurrentNo = 0

    End Sub

    'EBhETCYύXꂽƂ̏
    Private Sub frmMain_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize

        Dim newSize As New Size
        Dim newLocation As New Point

        newSize.Width = (Me.Width - AxFvxDisplayEx1.Left - 25) / 2
        newSize.Height = (Me.Height - AxFvxDisplayEx1.Top - 50) / 2
        AxFvxDisplayEx1.Size = newSize
        AxFvxDisplayEx2.Size = newSize
        AxFvxDisplayEx3.Size = newSize
        AxFvxDisplayEx4.Size = newSize

        newLocation.X = AxFvxDisplayEx1.Location.X + AxFvxDisplayEx1.Size.Width + 15
        newLocation.Y = AxFvxDisplayEx1.Location.Y
        AxFvxDisplayEx2.Location = newLocation

        newLocation.X = AxFvxDisplayEx1.Location.X
        newLocation.Y = AxFvxDisplayEx1.Size.Height + 20
        AxFvxDisplayEx3.Location = newLocation

        newLocation.X = AxFvxDisplayEx2.Location.X
        newLocation.Y = AxFvxDisplayEx3.Location.Y
        AxFvxDisplayEx4.Location = newLocation

    End Sub

    'AScope\؂ւ
    Private Sub chkAScope_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkAScope.CheckedChanged

        If chkAScope.Checked Then
            AxFvxDisplayEx1.AScopeMode = FVXCOMDISPLAYEXLib.DISPLAYEX_ASCOPE_MODE.DISPLAYEX_AScopeAuto
            AxFvxDisplayEx2.AScopeMode = FVXCOMDISPLAYEXLib.DISPLAYEX_ASCOPE_MODE.DISPLAYEX_AScopeAuto
            AxFvxDisplayEx3.AScopeMode = FVXCOMDISPLAYEXLib.DISPLAYEX_ASCOPE_MODE.DISPLAYEX_AScopeAuto
            AxFvxDisplayEx4.AScopeMode = FVXCOMDISPLAYEXLib.DISPLAYEX_ASCOPE_MODE.DISPLAYEX_AScopeAuto
        Else
            AxFvxDisplayEx1.AScopeMode = FVXCOMDISPLAYEXLib.DISPLAYEX_ASCOPE_MODE.DISPLAYEX_AScopeDisable
            AxFvxDisplayEx2.AScopeMode = FVXCOMDISPLAYEXLib.DISPLAYEX_ASCOPE_MODE.DISPLAYEX_AScopeDisable
            AxFvxDisplayEx3.AScopeMode = FVXCOMDISPLAYEXLib.DISPLAYEX_ASCOPE_MODE.DISPLAYEX_AScopeDisable
            AxFvxDisplayEx4.AScopeMode = FVXCOMDISPLAYEXLib.DISPLAYEX_ASCOPE_MODE.DISPLAYEX_AScopeDisable
        End If

    End Sub

    '\{minus
    Private Sub btnDispMinus_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDispMinus.Click

        AxFvxDisplayEx1.Magnification = AxFvxDisplayEx1.Magnification - 0.5
        AxFvxDisplayEx2.Magnification = AxFvxDisplayEx1.Magnification
        AxFvxDisplayEx3.Magnification = AxFvxDisplayEx1.Magnification
        AxFvxDisplayEx4.Magnification = AxFvxDisplayEx1.Magnification

        If AxFvxDisplayEx1.Magnification <= 0.5 Then
            btnDispMinus.Enabled = False
        Else
            btnDispMinus.Enabled = True
        End If
        btnDispPlus.Enabled = True

    End Sub

    '\{plus
    Private Sub btnDispPlus_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDispPlus.Click

        AxFvxDisplayEx1.Magnification = AxFvxDisplayEx1.Magnification + 0.5
        AxFvxDisplayEx2.Magnification = AxFvxDisplayEx1.Magnification
        AxFvxDisplayEx3.Magnification = AxFvxDisplayEx1.Magnification
        AxFvxDisplayEx4.Magnification = AxFvxDisplayEx1.Magnification

        If AxFvxDisplayEx1.Magnification > 10.0# Then
            btnDispPlus.Enabled = False
        Else
            btnDispPlus.Enabled = True
        End If
        btnDispMinus.Enabled = True

    End Sub

    '{\
    Private Sub btnDisp1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDisp1.Click

        AxFvxDisplayEx1.Magnification = 1
        AxFvxDisplayEx2.Magnification = 1
        AxFvxDisplayEx3.Magnification = 1
        AxFvxDisplayEx4.Magnification = 1

        btnDispPlus.Enabled = True
        btnDispMinus.Enabled = True

    End Sub

    'tʕ\
    Private Sub btnDispFull_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDispFull.Click

        Dim dblScaleX As Double
        Dim dblScaleY As Double

        dblScaleX = AxFvxDisplayEx1.Width / AxFvxImage1.ImageWidth
        dblScaleY = AxFvxDisplayEx1.Height / AxFvxImage1.ImageHeight

        If dblScaleX < dblScaleY Then
            AxFvxDisplayEx1.Magnification = dblScaleX
            AxFvxDisplayEx2.Magnification = dblScaleX
            AxFvxDisplayEx3.Magnification = dblScaleX
            AxFvxDisplayEx4.Magnification = dblScaleX
        Else
            AxFvxDisplayEx1.Magnification = dblScaleY
            AxFvxDisplayEx2.Magnification = dblScaleY
            AxFvxDisplayEx3.Magnification = dblScaleY
            AxFvxDisplayEx4.Magnification = dblScaleY
        End If

        btnDispPlus.Enabled = True
        btnDispMinus.Enabled = True

    End Sub

    'rfIItZbg
    Private Sub trcOffSet_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles trcOffSet.Scroll
        Try
            If m_blnVideoOpened And m_bCanOffSet Then
                txtOffset.Text = trcOffSet.Value
                AxFvxVideo1.SetVideoOffset(trcOffSet.Value)
                AxFvxVideo2.SetVideoOffset(trcOffSet.Value)
            End If
        Catch
            Dim intErr As Integer
            'G[
            AxFvxVideo1.GetErrReport(intErr)
            MsgBox(GetFvxVideoErrMsg(intErr), vbExclamation, "G[")
        End Try
    End Sub

    'IԐݒ
    Private Sub trcExposure_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles trcExposure.Scroll
        Try
            If m_blnVideoOpened And m_bCanExposure Then
                txtExposure.Text = trcExposure.Value
                AxFvxVideo1.SetExposureTime(trcExposure.Value * 1000)
                AxFvxVideo2.SetExposureTime(trcExposure.Value * 1000)
            End If
        Catch
            Dim intErr As Integer
            'G[
            AxFvxVideo1.GetErrReport(intErr)
            MsgBox(GetFvxVideoErrMsg(intErr), vbExclamation, "G[")
        End Try

    End Sub

    'HWQlxݒ
    Private Sub trcBinLevel_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles trcBinLevel.Scroll
        Try
            If m_blnVideoOpened And m_blnCanHWBinarize Then
                txtBinLevel.Text = trcBinLevel.Value
                AxFvxVideo1.SetBinarizeTheshold(trcBinLevel.Value)
                AxFvxVideo2.SetBinarizeTheshold(trcBinLevel.Value)
            End If
        Catch
            Dim intErr As Integer
            'G[
            AxFvxVideo1.GetErrReport(intErr)
            MsgBox(GetFvxVideoErrMsg(intErr), vbExclamation, "G[")

        End Try
    End Sub

    'HWQlon/off
    Private Sub cmbImageType_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmbImageType.SelectedIndexChanged

        If m_blnVideoOpened Then
            AxFvxVideo1.SetBinarizeMode(cmbImageType.SelectedIndex)
            AxFvxVideo2.SetBinarizeMode(cmbImageType.SelectedIndex)
            AxFvxVideo1.ChangeImageSize(AxFvxImage1.GetOcx())
            AxFvxVideo2.ChangeImageSize(AxFvxImage2.GetOcx())
        End If

    End Sub

    'rfIݒt@C̍Đݒ
    Private Sub btnResetVideoConfFile_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnResetVideoConfFile.Click
        't[Ȃ΁A~B
        If m_bInsFreerun Then
            Timer1.Stop()
            Timer1.Enabled = False
            btnGrab.Enabled = True
            btnFreerun.Text = "Freerun"
            m_bInsFreerun = False
        End If

        'rfIfoCX̑I
        setVideoConfFile()

    End Sub
    '荞
    Private Sub btnGrab_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGrab.Click

        Dim dblTime As Double
        Dim intErr As Integer

        AxFvxPerformanceCounter1.StartCount()   'ԑJn

        '捞
        intErr = fnGrabSync()
        AxFvxPerformanceCounter1.StopCount(dblTime)    'ԑI

        If intErr <> 0 Then
            MsgBox("捞G[ (" + intErr.ToString + ")", vbExclamation, "G[")
        Else
            '荞񂾉摜ʂɕ\
            fnDrawImage()
        End If

        txtGrabTime.Text = dblTime.ToString("0.00ms")

    End Sub

    't[iA荞݁jstart/stop
    Private Sub btnFreerun_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnFreerun.Click

        If m_bInsFreerun Then
            Timer1.Enabled = False
            btnGrab.Enabled = True
            cmbTrigger.Enabled = True
            cmbImageType.Enabled = True
            btnFreerun.Text = "Freerun"
        Else
            Timer1.Interval = 100
            Timer1.Start()
            btnGrab.Enabled = False
            cmbTrigger.Enabled = False
            cmbImageType.Enabled = False
            btnFreerun.Text = "Stop"
        End If

        m_bInsFreerun = Not m_bInsFreerun
        Application.DoEvents()

    End Sub

    't[iA荞݁j
    Private Sub Timer1_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        Dim dblTime As Double
        Dim intErr As Integer

        Timer1.Stop()

        If m_blnVideoOpened Then
            AxFvxPerformanceCounter1.StartCount()

            '捞
            intErr = fnGrabSync()
            AxFvxPerformanceCounter1.StopCount(dblTime)
            txtGrabTime.Text = dblTime.ToString("0.00ms")
            Timer1.Enabled = True

            If intErr <> 0 Then
                MsgBox("捞G[ (" + intErr.ToString + ")", vbExclamation, "G[")
                Timer1.Enabled = False
            End If

            '摜\
            fnDrawImage()
        End If

    End Sub

    '摜̕ۑ
    Private Sub btnSaveImage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSaveImage.Click

        SaveFileDialog1.InitialDirectory = Application.StartupPath
        SaveFileDialog1.Filter = "bitmap file(*.bmp)|*.bmp"
        SaveFileDialog1.DefaultExt = "*.bmp"
        SaveFileDialog1.ShowDialog()

        If SaveFileDialog1.FileName.Length > 0 Then
            '2x2ۑ܂B
            Try
                'FvxFileAccesspFvxImaget@Cɕۑ
                AxFvxImage1.CurrentNo = 0
                AxFvxFileAccess1.FilePath = SaveFileDialog1.FileName().Replace(".bmp", "_1-1.bmp")
                AxFvxFileAccess1.SaveBitmap(AxFvxImage1.GetOcx())
                AxFvxImage1.CurrentNo = 1
                AxFvxFileAccess1.FilePath = SaveFileDialog1.FileName().Replace(".bmp", "_1-2.bmp")
                AxFvxFileAccess1.SaveBitmap(AxFvxImage1.GetOcx())

                AxFvxImage2.CurrentNo = 0
                AxFvxFileAccess1.FilePath = SaveFileDialog1.FileName().Replace(".bmp", "_2-1.bmp")
                AxFvxFileAccess1.SaveBitmap(AxFvxImage1.GetOcx())
                AxFvxImage2.CurrentNo = 1
                AxFvxFileAccess1.FilePath = SaveFileDialog1.FileName().Replace(".bmp", "_2-2.bmp")
                AxFvxFileAccess1.SaveBitmap(AxFvxImage1.GetOcx())

            Catch
                Dim intErr As Integer
                AxFvxFileAccess1.GetErrReport(intErr)
                MsgBox("ۑɎs܂B(ErrCode=" + intErr.ToString() + ")", vbExclamation, "ۑs")
            Finally
                AxFvxImage1.CurrentNo = 0
                AxFvxImage2.CurrentNo = 0
            End Try
        End If

    End Sub

    'gK[hݒ
    Private Sub cmbTrigger_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmbTrigger.SelectedIndexChanged

        If m_blnVideoOpened Then
            AxFvxVideo1.SetTrigger(cmbTrigger.SelectedIndex + 1)
            AxFvxVideo2.SetTrigger(2)
        End If

    End Sub

    'FvxVideoG[bZ[W擾
    Private Function GetFvxVideoErrMsg(ByVal intErr As Integer) As String

        Select Case (intErr)
            Case 6001
                GetFvxVideoErrMsg = "\ȂG[łB"
            Case 6002
                GetFvxVideoErrMsg = "T|[gĂ܂B"
            Case 6005
                GetFvxVideoErrMsg = "p[^słB"
            Case 6010
                GetFvxVideoErrMsg = "̊mۂɎs܂B"
            Case 6015
                GetFvxVideoErrMsg = "DLLt@C݂܂B"
            Case 6020
                GetFvxVideoErrMsg = "foCX̃I[vɎs܂B"
            Case 6021
                GetFvxVideoErrMsg = "ɃI[vĂ܂B"
            Case 6030
                GetFvxVideoErrMsg = "Lv`I[vĂ܂B"
            Case 6031
                GetFvxVideoErrMsg = "Lv`{[h܂B"
            Case 6032
                GetFvxVideoErrMsg = "foCXIDsłB"
            Case 6037
                GetFvxVideoErrMsg = "GrabASynĉߏs܂B"
            Case 6040
                GetFvxVideoErrMsg = "摜荞݂Ɏs܂B"
            Case 6041
                GetFvxVideoErrMsg = "^CAEg܂B"
            Case 6042
                GetFvxVideoErrMsg = "摜f[^słB"
            Case 6043
                GetFvxVideoErrMsg = "摜͂Ɏs܂B"
            Case 6044
                GetFvxVideoErrMsg = "Xe[^X`FbNɎs܂B"
            Case 6045
                GetFvxVideoErrMsg = "ݒ肵摜TCYvĂȂAWOIEBhEPݒ肳Ă܂B"
            Case 6046
                GetFvxVideoErrMsg = "摜̃bNɎs܂B"
            Case 6047
                GetFvxVideoErrMsg = "摜̃AbNɎs܂B"
            Case 6048
                GetFvxVideoErrMsg = "nhsłB"
            Case 6052
                GetFvxVideoErrMsg = "[h̕ύXɎs܂B"
            Case 6053
                GetFvxVideoErrMsg = "[h̎擾Ɏs܂B"
            Case 6054
                GetFvxVideoErrMsg = "Lv`TCY̕ύXɎs܂B"
            Case 6055
                GetFvxVideoErrMsg = "摜TCY擾Ɏs܂B"
            Case 6056
                GetFvxVideoErrMsg = "Lv`ItZbgݒɎs܂B"
            Case 6058
                GetFvxVideoErrMsg = "rfIItZbg̐ݒɎs܂B"
            Case 6060
                GetFvxVideoErrMsg = "IԂ̐ݒɎs܂B"
            Case 6061
                GetFvxVideoErrMsg = "IԂ̎擾Ɏs܂B"
            Case 6062
                GetFvxVideoErrMsg = "^CAEg̕ύXɎs܂B"
            Case 6063
                GetFvxVideoErrMsg = "^CAEg擾Ɏs܂B"
            Case 6066
                GetFvxVideoErrMsg = "2lݒɎs܂B"
            Case 6074
                GetFvxVideoErrMsg = "gK[h̕ύXɎs܂B"
            Case 6080
                GetFvxVideoErrMsg = "rfIݒt@C܂B"
            Case 6081
                GetFvxVideoErrMsg = "rfIݒt@CpXݒ肳Ă܂B"
            Case 6085
                GetFvxVideoErrMsg = "JR}ht@C܂B"
            Case 6100
                GetFvxVideoErrMsg = "SIOR}hgpł܂B"
            Case 6101
                GetFvxVideoErrMsg = "SIOR}h܂B"
            Case 6102
                GetFvxVideoErrMsg = "SIO^CAEg܂BJڑĂ邱ƂmFĂB"
            Case 6150
                GetFvxVideoErrMsg = "[Jobt@ȏ̃TCYw肵Ă܂B"
            Case 6200
                GetFvxVideoErrMsg = "JڑĂȂAdĂ܂B"
            Case 6201
                GetFvxVideoErrMsg = "J̏Ɏs܂B"
            Case 6202
                GetFvxVideoErrMsg = "JtbVɎs܂B"
            Case 6203
                GetFvxVideoErrMsg = "JZ[uɎs܂B"
            Case 6204
                GetFvxVideoErrMsg = "J[hɎs܂B"
            Case 6210
                GetFvxVideoErrMsg = "BitWidthݒɎs܂B"
            Case 6211
                GetFvxVideoErrMsg = "Bit擾Ɏs܂B"
            Case 6212
                GetFvxVideoErrMsg = "CC̐ݒɎs܂B"
            Case 6213
                GetFvxVideoErrMsg = "CC̎擾Ɏs܂B"
            Case 6214
                GetFvxVideoErrMsg = "SIO[hݒɎs܂B"
            Case 6216
                GetFvxVideoErrMsg = "SIOp[^̐ݒɎs܂B"
            Case 6217
                GetFvxVideoErrMsg = "SIOp[^̎擾Ɏs܂B"
            Case 6218
                GetFvxVideoErrMsg = "WOIEBhE̐ݒɎs܂B"
            Case 6220
                GetFvxVideoErrMsg = "WOI Enable̐ݒɎs܂B"
            Case 6222
                GetFvxVideoErrMsg = "WOI[h̐ݒɎs܂B"
            Case 6221
                GetFvxVideoErrMsg = "WOI Enable̎擾Ɏs܂B"
            Case 6223
                GetFvxVideoErrMsg = "WOI[h̎擾Ɏs܂B "
            Case 6360
                GetFvxVideoErrMsg = "摜荞݂Ɏs܂B"
            Case Else
                GetFvxVideoErrMsg = "sȃG["
        End Select

    End Function

End Class
